=== debian/changelog ===
ntpsec (1.2.1+dfsg1-4) unstable; urgency=high

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster

  [ Richard Laager ]
  * Remove direct libssl1.1 Depends (Closes: 1006627)

 -- Richard Laager <rlaager@debian.org>  Mon, 28 Feb 2022 18:13:12 -0600

ntpsec (1.2.1+dfsg1-3) unstable; urgency=high

  * Mention NTS in the package description (Closes: 1004010)
  * Backport some changes:
    - Some startup logging fixes
    - Some seccomp fixes for newer glibc / other architectures
    - OpenSSL 3.0 support (Closes: 1005716)

 -- Richard Laager <rlaager@debian.org>  Tue, 15 Feb 2022 20:12:55 -0600

ntpsec (1.2.1+dfsg1-2) unstable; urgency=medium

  * Fix ntpq man page formatting (Closes: 998072)

 -- Richard Laager <rlaager@debian.org>  Fri, 29 Oct 2021 18:54:28 -0500

ntpsec (1.2.1+dfsg1-1) unstable; urgency=medium

  * Fix ntpdate -d.
    Thanks to Bernhard <rep.dot.nop@gmail.com> (Closes: 994819)
  * New upstream version:
    - Update the SHM gpsd documentation
    - ntpdig: continue instead of exit on IPv6 when there is none. solves #680
    - ntpq: solve #689 - 'ntpq -c raw -c readvar' crashes ...
    - ntpq: solve #690 - ntpq does not print associd when 0 ...
    - ntpdig: Fix steplimit option.
    - Improve ntpdate script.
    - ntpdig: Try to handle gaierror better ...
    - Fix parsing of commandline parameter 'P'
    - ntp.util: Shorten ntpq/ntpmon peers common output generation.
    - ntpq, ntpmon: Add dextral peers mode ...
    - ntpq: -c rv should return associd only when variable(s) not passed.
    - Don't generate # into ASCIIfied keys.
  * Stop using removed --build-epoch
  * Update Standards-Version to 4.6.0 (no changes)

 -- Richard Laager <rlaager@debian.org>  Sat, 25 Sep 2021 18:43:40 -0500
