=== debian/watch ===
version=4
opts="\
    compression=xz,repack,\
    dversionmangle=s/\+dfsg\d*$//,\
    oversionmangle=s/$/+dfsg1/,\
    pgpsigurlmangle=s/$/.asc/" \
  https://ftp.ntpsec.org/pub/releases/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@ \
  debian debian/repack-waf
