## ntpsec 1.2.2%2Bdfsg1

=== debian/changelog ===
ntpsec (1.2.2+dfsg1-1.0nosystemd1) nosystemd; urgency=medium

  * No systemd/elogind
  * include runit acripts
  * include runit in post/pre install scripts 

 -- anticapitalista <antix@operamail.com>  Wed, 01 Feb 2023 18:06:12 +0200

ntpsec (1.2.2+dfsg1-1) unstable; urgency=medium

  * New upstream version
    - Restore/cleanup NTPv1 support
    - NTS supports partial wildcards, for example *.example.com
    - Work on documentation, ntpdate, ntpheat, ntploggpg, ntpq’s sysstats,
      ntpviz, and seccomp.
    - NTP auth no longer breaks on NULs.
    - The NTS server now saves 10 days worth of cookie keys. This will allow
      clients that only poll once a day to use NTS without using NTS-KE to
      keep cookies up to date.
    - rawstats now logs dropped packets and their BOGON code
    - Add 4 or 6 to DNS/NTS RefID tags to indicate that the DNS or NTS-KE has
      succeeded but NTP has not worked yet.
    - Fix hash validation in ntpleapfetch again
  * Update Standards-Version to 4.6.2 (no changes)
  * Write pidfile in parent (Closes: 1023023)

 -- Richard Laager <rlaager@debian.org>  Mon, 16 Jan 2023 21:50:45 -0600

ntpsec (1.2.1+dfsg1-8) unstable; urgency=medium

  * Fix ntpdate-debian error on ntp.conf (Closes: 1020865)
  * ntpdig: Only show socket error messages in debug (Closes: 971523)
  * ntpdig: Continue on errors in non-concurrent mode
  * ntpdate: Disable JSON (Closes: 1020865)

 -- Richard Laager <rlaager@debian.org>  Tue, 18 Oct 2022 01:15:33 -0500

ntpsec (1.2.1+dfsg1-7) unstable; urgency=medium

  * watch: Use FTP
  * watch: Fix syntax to help lintian
  * ntplogtemp: Fix printing blank line on exit

 -- Richard Laager <rlaager@debian.org>  Tue, 10 May 2022 21:30:41 -0500

ntpsec (1.2.1+dfsg1-6) unstable; urgency=low

  * Add a NEWS.Debian bit with transitional details for those coming from
    the ntp package.  Unfortunately, apt-listchanges will not show this
    to those upgrading from ntp due to source vs binary version number
    differences relating to the transition.

 -- Richard Laager <rlaager@debian.org>  Sun, 03 Apr 2022 15:45:01 -0500

ntpsec (1.2.1+dfsg1-5) experimental; urgency=medium

  * Add ntpd.service alias
  * Add ntp transitional packages (Closes: 1003966)

 -- Richard Laager <rlaager@debian.org>  Tue, 08 Mar 2022 00:37:42 -0600
