=== debian/control ===
--- 
+++ 
@@ -18,13 +18,12 @@
                python3,
                python3-dev,
                python3-gps,
-               systemd,
                xsltproc,
                xz-utils,
 Build-Conflicts: libavahi-compat-libdnssd-dev,
                  libwww-dev,
                  libwww-ssl-dev,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/ntpsec
 Vcs-Git: https://salsa.debian.org/debian/ntpsec.git
@@ -46,11 +45,10 @@
           certbot,
           ntpsec-doc,
           ntpsec-ntpviz,
-Conflicts: ntp,
-           ntpdate,
-           time-daemon,
+Breaks: ntp (<< 1:4.2.8p15+dfsg-2~),
+Conflicts: time-daemon,
 Provides: time-daemon,
-Replaces: ntp,
+Replaces: ntp (<< 1:4.2.8p15+dfsg-2~),
           time-daemon,
 Description: Network Time Protocol daemon and utility programs
  NTP, the Network Time Protocol, is used to keep computer clocks
@@ -74,12 +72,11 @@
 Package: ntpsec-ntpdate
 Architecture: any
 Depends: netbase,
-         python3,
-         python3-ntp (= ${binary:Version}),
-         ${misc:Depends},
-         ${shlibs:Depends},
-Conflicts: ntpdate,
-Replaces: ntpdate,
+         ntpsec-ntpdig (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends},
+Breaks: ntpdate (<< 1:4.2.8p15+dfsg-2~),
+Replaces: ntpdate (<< 1:4.2.8p15+dfsg-2~),
 Description: client for setting system time from NTP servers
  NTP, the Network Time Protocol, is used to keep computer clocks
  accurate by synchronizing them over the Internet or a local network,
@@ -99,6 +96,30 @@
  If the full NTP daemon from the package "ntpsec" is installed, then
  ntpsec-ntpdate is not necessary.
 
+Package: ntpsec-ntpdig
+Architecture: any
+Depends: python3 (>= 3.3),
+         python3-ntp (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends},
+Breaks: ntpsec-ntpdate (<< 1.2.1+dfsg1-5~),
+        sntp (<< 1:4.2.8p15+dfsg-2~),
+Replaces: ntpsec-ntpdate (<< 1.2.1+dfsg1-5~),
+          sntp (<< 1:4.2.8p15+dfsg-2~),
+Description: ntpdig SNTP client
+ NTP, the Network Time Protocol, is used to keep computer clocks
+ accurate by synchronizing them over the Internet or a local network,
+ or by following an accurate hardware receiver that interprets GPS,
+ DCF-77, or similar time signals.
+ .
+ ntpdig can be used as an SNTP client to query a NTP or SNTP server
+ and either display the time or set the local system's time.  It is not
+ sufficient, however, for maintaining an accurate clock in the long run.
+ .
+ This is the NTPsec version of ntpdig, which is equivalent to the sntp
+ utility.  NTPsec is a secure, hardened, and improved implementation
+ derived from the original NTP project.
+
 Package: ntpsec-ntpviz
 Architecture: any
 Depends: adduser,
@@ -128,6 +149,8 @@
 Package: ntpsec-doc
 Architecture: all
 Depends: ${misc:Depends},
+Breaks: ntp-doc (<< 1:4.2.8p15+dfsg-2~),
+Replaces: ntp-doc (<< 1:4.2.8p15+dfsg-2~),
 Section: doc
 Multi-Arch: foreign
 Description: Network Time Protocol documentation
@@ -161,3 +184,40 @@
  .
  This is part of NTPsec.  NTPsec is a secure, hardened, and improved
  implementation derived from the original NTP project.
+
+Package: ntp
+Architecture: all
+Section: oldlibs
+Depends: ntpsec,
+         ${misc:Depends},
+Description: Network Time Protocol daemon/utilities (transitional package)
+ This is a dummy transitional package to transition to NTPsec.
+ It can be safely removed.
+
+Package: ntp-doc
+Architecture: all
+Section: oldlibs
+Depends: ntpsec-doc,
+         ${misc:Depends},
+Description: Network Time Protocol docs (transitional package)
+ This is a dummy transitional package to transition to NTPsec.
+ It can be safely removed.
+
+Package: ntpdate
+Architecture: all
+Section: oldlibs
+Depends: ntpsec-ntpdate,
+         ${misc:Depends},
+Description: Network Time Protocol client (transitional package)
+ This is a dummy transitional package to transition to NTPsec.
+ It can be safely removed.
+
+Package: sntp
+Architecture: all
+Section: oldlibs
+Depends: ntpsec-ntpdig,
+         ${misc:Depends},
+Description: Network Time Protocol client (transitional package)
+ This is a transitional package to transition to NTPsec.
+ It can be safely removed once all uses of sntp(1) have been converted to
+ run ntpdig instead.
